package cost.speed;

import java.text.SimpleDateFormat;
import java.util.*;

public class New {

	static int COUNT = 100 * 10000;

	public static void main(String[] args) {
		double sum = 0;
		for (int i = 0; i < 10; i++) {
			// sum += new_Object();
			// sum += new_String();
			// sum += new_StringBuilder();
			// sum += new_StringBuffer();
			// sum += new_ArrayList();
			// sum += new_HashMap();
			// sum += new_Throwable();
			// sum += new_Exception();
			// sum += new_RuntimeException();
			// sum += new_DateFormat();
			sum += new_Thread();

			System.gc();
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
		}
		System.out.println(sum / 10);
	}

	static double new_Object() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * 10; i++) {
			new Object();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("ob:" + e / 10.0);
		return e / 10.0;
	}

	static double new_String() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * 10; i++) {
			new String();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("st:" + e / 10.0);
		return e / 10.0;
	}

	static double new_StringBuffer() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * 10; i++) {
			new StringBuffer();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("sb" + e / 10.0);
		return e / 10.0;
	}

	static double new_StringBuilder() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * 10; i++) {
			new StringBuilder();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("sb:" + e / 10.0);
		return e / 10.0;
	}

	static double new_ArrayList() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT; i++) {
			new ArrayList();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("al:" + e);
		return e;
	}

	static double new_HashMap() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT; i++) {
			new HashMap();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("hm:" + e);
		return e;
	}

	static double new_RuntimeException() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT; i++) {
			new RuntimeException();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("re:" + e);
		return e;
	}

	static double new_Exception() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT; i++) {
			new Exception();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("ex:" + e);
		return e;
	}

	static double new_Throwable() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT; i++) {
			new Throwable();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("th:" + e);
		return e;
	}

	static double new_Thread() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT / 100; i++) {
			new Thread();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("th:" + e * 100);
		return e * 100;
	}

	static double new_DateFormat() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT / 100; i++) {
			new SimpleDateFormat();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("df:" + e * 100);
		return e * 100;
	}
}
